| OGRE 1.11.1 Object-Oriented Graphics Rendering Engine

Public Member Functions | Static Public Member Functions | List of all members
Ogre::GLSLProgram Class Referenceabstract

C++ encapsulation of GLSL program object. More...

`#include <OgreGLSLProgram.h>`

Inheritance diagram for Ogre::GLSLProgram:
[legend]

## Public Member Functions
virtual void | activate (void)=0
| Makes a program object active by making sure it is linked and then putting it in use. More...
void | bindFixedAttributes (GLuint program)
void | extractLayoutQualifiers (void)
GLSLShader * | getComputeShader () const
GLSLShader * | getDomainShader () const
GLSLShader * | getFragmentShader () const
GLSLShader * | getGeometryShader () const
uint | getGLProgramHandle (void) const
| Get the GL Handle for the program object. More...
GLSLShader * | getHullShader () const
GLSLShader * | getVertexShader () const
bool | isSkeletalAnimationIncluded (void) const
| Returns whether the linked program includes the required instructions to perform skeletal animation. More...
bool | isUsingShader (GLSLShaderCommon *shader) const
| query if the program is using the given shader More...
void | setSkeletalAnimationIncluded (bool included)
| Sets whether the linked program includes the required instructions to perform skeletal animation. More...
void | setTransformFeedbackVaryings (const std::vector< String > &nameStrings)
virtual void | updateAtomicCounters (GpuProgramParametersSharedPtr params, uint16 mask, GpuProgramType fromProgType)=0
virtual void | updatePassIterationUniforms (GpuProgramParametersSharedPtr params)=0
| Updates program object uniforms using data from pass iteration GpuProgramParameters. More...
virtual void | updateUniformBlocks (GpuProgramParametersSharedPtr params, uint16 mask, GpuProgramType fromProgType)=0
| Updates program object uniform blocks using data from GpuProgramParameters. More...
virtual void | updateUniforms (GpuProgramParametersSharedPtr params, uint16 mask, GpuProgramType fromProgType)=0
| Updates program object uniforms using data from GpuProgramParameters. More...

## Static Public Member Functions
static int32 | getFixedAttributeIndex (VertexElementSemantic semantic, uint index)
| Get the fixed attribute bindings normally used by GL for a semantic. More...
static void | useTightAttributeLayout ()
| use alternate vertex attribute layout using only 8 vertex attributes More...

## Detailed Description

C++ encapsulation of GLSL program object.

## Member Function Documentation

## ◆ bindFixedAttributes()

void Ogre::GLSLProgram::bindFixedAttributes | ( | GLuint | program | ) |

## ◆ getVertexShader()

GLSLShader* Ogre::GLSLProgram::getVertexShader | ( |  | ) | const
| inline

## ◆ getHullShader()

GLSLShader* Ogre::GLSLProgram::getHullShader | ( |  | ) | const
| inline

## ◆ getDomainShader()

GLSLShader* Ogre::GLSLProgram::getDomainShader | ( |  | ) | const
| inline

## ◆ getGeometryShader()

GLSLShader* Ogre::GLSLProgram::getGeometryShader | ( |  | ) | const
| inline

## ◆ getFragmentShader()

GLSLShader* Ogre::GLSLProgram::getFragmentShader | ( |  | ) | const
| inline

## ◆ getComputeShader()

GLSLShader* Ogre::GLSLProgram::getComputeShader | ( |  | ) | const
| inline

## ◆ isUsingShader()

bool Ogre::GLSLProgram::isUsingShader | ( | GLSLShaderCommon * | shader | ) | const
| inline virtual

query if the program is using the given shader

Implements Ogre::GLSLProgramCommon.

## ◆ updateAtomicCounters()

virtual void Ogre::GLSLProgram::updateAtomicCounters | ( | GpuProgramParametersSharedPtr | params,
|  | uint16 | mask,
|  | GpuProgramType | fromProgType
| ) |  |
| pure virtual

Implemented in Ogre::GLSLSeparableProgram, and Ogre::GLSLMonolithicProgram.

## ◆ setTransformFeedbackVaryings()

void Ogre::GLSLProgram::setTransformFeedbackVaryings | ( | const std::vector< String > & | nameStrings | ) |

## ◆ extractLayoutQualifiers()

void Ogre::GLSLProgramCommon::extractLayoutQualifiers | ( | void |  | ) |
| inherited

## ◆ setSkeletalAnimationIncluded()

void Ogre::GLSLProgramCommon::setSkeletalAnimationIncluded | ( | bool | included | ) |
| inline inherited

Sets whether the linked program includes the required instructions to perform skeletal animation.

Remarks
  If this is set to true, OGRE will not blend the geometry according to skeletal animation, it will expect the vertex program to do it.

## ◆ isSkeletalAnimationIncluded()

bool Ogre::GLSLProgramCommon::isSkeletalAnimationIncluded | ( | void |  | ) | const
| inline inherited

Returns whether the linked program includes the required instructions to perform skeletal animation.

Remarks
  If this returns true, OGRE will not blend the geometry according to skeletal animation, it will expect the vertex program to do it.

## ◆ getGLProgramHandle()

uint Ogre::GLSLProgramCommon::getGLProgramHandle | ( | void |  | ) | const
| inline inherited

Get the GL Handle for the program object.

## ◆ activate()

virtual void Ogre::GLSLProgramCommon::activate | ( | void |  | ) |
| pure virtual inherited

Makes a program object active by making sure it is linked and then putting it in use.

Implemented in Ogre::GLSLSeparableProgram, Ogre::GLSLESProgramPipeline, Ogre::GLSL::GLSLLinkProgram, Ogre::GLSLMonolithicProgram, and Ogre::GLSLESLinkProgram.

## ◆ updateUniforms()

virtual void Ogre::GLSLProgramCommon::updateUniforms | ( | GpuProgramParametersSharedPtr | params,
|  | uint16 | mask,
|  | GpuProgramType | fromProgType
| ) |  |
| pure virtual inherited

Updates program object uniforms using data from GpuProgramParameters.

Normally called by GLSLShader::bindParameters() just before rendering occurs.

Implemented in Ogre::GLSLSeparableProgram, Ogre::GLSL::GLSLLinkProgram, Ogre::GLSLMonolithicProgram, Ogre::GLSLESLinkProgram, and Ogre::GLSLESProgramPipeline.

## ◆ updateUniformBlocks()

virtual void Ogre::GLSLProgramCommon::updateUniformBlocks | ( | GpuProgramParametersSharedPtr | params,
|  | uint16 | mask,
|  | GpuProgramType | fromProgType
| ) |  |
| pure virtual inherited

Updates program object uniform blocks using data from GpuProgramParameters.

Normally called by GLSLShader::bindParameters() just before rendering occurs.

Implemented in Ogre::GLSLSeparableProgram, Ogre::GLSL::GLSLLinkProgram, Ogre::GLSLMonolithicProgram, Ogre::GLSLESLinkProgram, and Ogre::GLSLESProgramPipeline.

## ◆ updatePassIterationUniforms()

virtual void Ogre::GLSLProgramCommon::updatePassIterationUniforms | ( | GpuProgramParametersSharedPtr | params | ) |
| pure virtual inherited

Updates program object uniforms using data from pass iteration GpuProgramParameters.

Normally called by GLSLShader::bindMultiPassParameters() just before multi pass rendering occurs.

Implemented in Ogre::GLSLSeparableProgram, Ogre::GLSL::GLSLLinkProgram, Ogre::GLSLMonolithicProgram, Ogre::GLSLESLinkProgram, and Ogre::GLSLESProgramPipeline.

## ◆ getFixedAttributeIndex()

static int32 Ogre::GLSLProgramCommon::getFixedAttributeIndex | ( | VertexElementSemantic | semantic,
|  | uint | index
| ) |  |
| static inherited

Get the fixed attribute bindings normally used by GL for a semantic.

## ◆ useTightAttributeLayout()

static void Ogre::GLSLProgramCommon::useTightAttributeLayout | ( |  | ) |
| static inherited

use alternate vertex attribute layout using only 8 vertex attributes

For "Vivante GC1000" and "VideoCore IV" (notably in Raspberry Pi) on GLES2

The documentation for this class was generated from the following file:

- Plus/include/GLSL/OgreGLSLProgram.h